namespace org.accordproject.cicero.dom;
using org.accordproject.cicero.contract;
using AccordProject.Concerto;
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.dom", Version = "0.2.0", Name = "Metadata")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Metadata : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.dom@0.2.0.Metadata";
   public string version { get; set; }
   public string locale { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.dom", Version = "0.2.0", Name = "Element")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public abstract class Element : Asset {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.dom@0.2.0.Element";
   [AccordProject.Concerto.Identifier()]
   public string id { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.dom", Version = "0.2.0", Name = "ContractTemplate")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class ContractTemplate : Element {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.dom@0.2.0.ContractTemplate";
   public Metadata metadata { get; set; }
   public Section? content { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.dom", Version = "0.2.0", Name = "ClauseTemplate")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class ClauseTemplate : Element {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.dom@0.2.0.ClauseTemplate";
   public Metadata metadata { get; set; }
   public Section? content { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.dom", Version = "0.2.0", Name = "Text")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Text : Element {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.dom@0.2.0.Text";
   public string content { get; set; }
   public string locale { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.dom", Version = "0.2.0", Name = "Parameter")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Parameter : Element {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.dom@0.2.0.Parameter";
   public string name { get; set; }
   public string description { get; set; }
   public string type { get; set; }
   public BooleanExpression? constraint { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.dom", Version = "0.2.0", Name = "Choice")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Choice : Element {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.dom@0.2.0.Choice";
   public Element[] options { get; set; }
   public bool required { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.dom", Version = "0.2.0", Name = "Conditional")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Conditional : Element {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.dom@0.2.0.Conditional";
   public Element element { get; set; }
   public BooleanExpression predicate { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.dom", Version = "0.2.0", Name = "Clause")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public abstract class Clause : Element {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.dom@0.2.0.Clause";
   public string templateUri { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.dom", Version = "0.2.0", Name = "SigningParty")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class SigningParty : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.dom@0.2.0.SigningParty";
   public Text description { get; set; }
   public AccordParty party { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.dom", Version = "0.2.0", Name = "Signatures")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Signatures : Element {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.dom@0.2.0.Signatures";
   public SigningParty[] parties { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.dom", Version = "0.2.0", Name = "Link")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Link : Element {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.dom@0.2.0.Link";
   public Element reference { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.dom", Version = "0.2.0", Name = "Section")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Section : Element {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.dom@0.2.0.Section";
   public Text heading { get; set; }
   public Element?[] children { get; set; }
   public bool pageBreak { get; set; }
}
[System.Text.Json.Serialization.JsonConverter(typeof(System.Text.Json.Serialization.JsonStringEnumConverter))]
public enum ListStyle {
      ORDERED,
      UNORDERED,
      SINGLE_LINE,
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.dom", Version = "0.2.0", Name = "List")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class List : Section {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.dom@0.2.0.List";
   public ListStyle style { get; set; }
   public string separator { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.dom", Version = "0.2.0", Name = "Script")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public abstract class Script : Element {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.dom@0.2.0.Script";
   public string language { get; set; }
   public string version { get; set; }
   public string code { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.dom", Version = "0.2.0", Name = "Declarations")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Declarations : Script {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.dom@0.2.0.Declarations";
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.dom", Version = "0.2.0", Name = "Expression")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public abstract class Expression : Script {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.dom@0.2.0.Expression";
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.dom", Version = "0.2.0", Name = "ElementExpression")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class ElementExpression : Expression {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.dom@0.2.0.ElementExpression";
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.cicero.dom", Version = "0.2.0", Name = "BooleanExpression")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class BooleanExpression : Expression {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.cicero.dom@0.2.0.BooleanExpression";
}
